117 lines
3.4 KiB
Diff
117 lines
3.4 KiB
Diff
From 915f7779592a69d1243427ed8e5e95285b6daa4f Mon Sep 17 00:00:00 2001
|
|
From: Stefan Hajnoczi <stefanha@redhat.com>
|
|
Date: Tue, 7 Oct 2025 10:17:00 -0400
|
|
Subject: [PATCH 36/52] iotests: add Linux loop device image creation test
|
|
|
|
RH-Author: Kevin Wolf <kwolf@redhat.com>
|
|
RH-MergeRequest: 504: virt-storage: Backport stable branch fixes
|
|
RH-Jira: RHEL-186384
|
|
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
RH-Acked-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
RH-Commit: [29/45] b46da09b4329cc3b3c3263f2ac62b3386035de8d (kmwolf/centos-qemu-kvm)
|
|
|
|
This qemu-iotests test case is based on the reproducer that Jean-Louis
|
|
Dupond <jean-louis@dupond.be> shared in
|
|
https://gitlab.com/qemu-project/qemu/-/issues/3127.
|
|
|
|
Signed-off-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
Message-ID: <20251007141700.71891-4-stefanha@redhat.com>
|
|
Reviewed-by: Vladimir Sementsov-Ogievskiy <vsementsov@yandex-team.ru>
|
|
Tested-by: Vladimir Sementsov-Ogievskiy <vsementsov@yandex-team.ru>
|
|
Tested-by: Fiona Ebner <f.ebner@proxmox.com>
|
|
Reviewed-by: Fiona Ebner <f.ebner@proxmox.com>
|
|
Reviewed-by: Kevin Wolf <kwolf@redhat.com>
|
|
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
|
|
(cherry picked from commit 59a1cf0cd31597d2f6e2c18dc400a1de8427d47d)
|
|
Signed-off-by: Michael Tokarev <mjt@tls.msk.ru>
|
|
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
|
|
---
|
|
tests/qemu-iotests/tests/loop-create-file | 59 +++++++++++++++++++
|
|
tests/qemu-iotests/tests/loop-create-file.out | 8 +++
|
|
2 files changed, 67 insertions(+)
|
|
create mode 100755 tests/qemu-iotests/tests/loop-create-file
|
|
create mode 100644 tests/qemu-iotests/tests/loop-create-file.out
|
|
|
|
diff --git a/tests/qemu-iotests/tests/loop-create-file b/tests/qemu-iotests/tests/loop-create-file
|
|
new file mode 100755
|
|
index 0000000000..5ec75b046b
|
|
--- /dev/null
|
|
+++ b/tests/qemu-iotests/tests/loop-create-file
|
|
@@ -0,0 +1,59 @@
|
|
+#!/usr/bin/env bash
|
|
+# group: quick
|
|
+#
|
|
+# SPDX-License-Identifier: GPL-2.0-or-later
|
|
+#
|
|
+# Copyright Red Hat, Inc.
|
|
+#
|
|
+# Test Linux loop device image creation
|
|
+#
|
|
+# This test verifies #3127 "qemu-img create fails on loop device with sector size 4096"
|
|
+# https://gitlab.com/qemu-project/qemu/-/issues/3127
|
|
+
|
|
+seq="$(basename $0)"
|
|
+echo "QA output created by $seq"
|
|
+
|
|
+status=1 # failure is the default!
|
|
+
|
|
+_cleanup() {
|
|
+ if [ -n "$loopdev" ]; then
|
|
+ sudo losetup --detach "$loopdev"
|
|
+ fi
|
|
+
|
|
+ _cleanup_test_img
|
|
+}
|
|
+
|
|
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
+
|
|
+# get standard environment, filters and checks
|
|
+cd ..
|
|
+. ./common.rc
|
|
+. ./common.filter
|
|
+
|
|
+_supported_fmt raw
|
|
+_supported_proto file
|
|
+_supported_os Linux
|
|
+
|
|
+if ! sudo -n losetup &>/dev/null; then
|
|
+ _notrun "sudo losetup not available"
|
|
+fi
|
|
+
|
|
+echo
|
|
+echo "=== Create image on a 4 KB sector size loop device ==="
|
|
+echo
|
|
+
|
|
+_make_test_img -f $IMGFMT 1M
|
|
+
|
|
+loopdev=$(sudo losetup --sector-size 4096 --find --show "$TEST_IMG")
|
|
+if [ -z "$loopdev" ]; then
|
|
+ _fail
|
|
+fi
|
|
+
|
|
+sudo $QEMU_IMG_PROG create -f raw "$loopdev" 1M | \
|
|
+ sed -e "s#/dev/loop[0-9]\\+#LOOPDEV#g"
|
|
+
|
|
+# success, all done
|
|
+echo
|
|
+echo '*** done'
|
|
+rm -f $seq.full
|
|
+status=0
|
|
diff --git a/tests/qemu-iotests/tests/loop-create-file.out b/tests/qemu-iotests/tests/loop-create-file.out
|
|
new file mode 100644
|
|
index 0000000000..32d4155695
|
|
--- /dev/null
|
|
+++ b/tests/qemu-iotests/tests/loop-create-file.out
|
|
@@ -0,0 +1,8 @@
|
|
+QA output created by loop-create-file
|
|
+
|
|
+=== Create image on a 4 KB sector size loop device ===
|
|
+
|
|
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1048576
|
|
+Formatting 'LOOPDEV', fmt=raw size=1048576
|
|
+
|
|
+*** done
|
|
--
|
|
2.52.0
|
|
|